/* gltest - small OpenGL tearing test program
 * Copyright (C) 2012-2013 Ralf Jung <post@ralfj.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */


#ifdef CON_GLES2
#include  <GLES2/gl2.h>
#else
#include <GL/gl.h>
#endif

/**
 * GNUC has the ability to check format strings that follow the syntax used in printf and others.
Hide the differences between different compilers in this GNUC_FORMAT_CHECK macro.
Copied from Wireshark sources.
*/
#if __GNUC__ >= 2
	#define GNUC_FORMAT_CHECK(archetype, string_index, first_to_check) __attribute__((format (archetype, string_index, first_to_check)))
#else
	#define GNUC_FORMAT_CHECK(archetype, string_index, first_to_check)
#endif

/* Function name resolving: Call this after initialising the context, but before any utility function is called */
typedef void (*T_proc)(void);
typedef T_proc (*T_glGetProcAddress)(char const *  procname);
void resolveFunctionPointers(T_glGetProcAddress p_glGetProcAddress);

/* The actual utility functions */
void die(const char *msg, ...) GNUC_FORMAT_CHECK(printf, 1, 2);
void checkGlError(const char *what);
void initialise2dProjection();
void drawQuad(GLfloat red, GLfloat green, GLfloat blue, GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2);
